searchData={"items":[{"type":"module","title":"ReqEmbed","doc":"[oEmbed](https://oembed.com) plugin for [Req](https://hex.pm/packages/req).\n\nSupports [discovery](https://oembed.com/#section4) and 300+ [providers](https://github.com/BeaconCMS/req_embed/blob/main/priv/providers.json).","ref":"ReqEmbed.html"},{"type":"module","title":"Usage - ReqEmbed","doc":"```elixir\nMix.install([\n  {:req, \"~> 0.5\"},\n  {:req_embed, \"~> 0.1\"}\n])\n\nreq = Req.new() |> ReqEmbed.attach()\n\nReq.get!(req, url: \"https://www.youtube.com/watch?v=XfELJU1mRMg\").body\n#=>\n# %ReqEmbed.Video{\n#   type: \"video\",\n#   version: \"1.0\",\n#   title: \"Rick Astley - Never Gonna Give You Up (Official Music Video)\",\n#   author_name: \"Supirorguy508\",\n#   author_url: \"https://www.youtube.com/@supirorguy5086\",\n#   provider_name: \"YouTube\",\n#   provider_url: \"https://www.youtube.com/\",\n#   cache_age: nil,\n#   thumbnail_url: \"https://i.ytimg.com/vi/XfELJU1mRMg/hqdefault.jpg\",\n#   thumbnail_width: 480,\n#   thumbnail_height: 360,\n#   html: \"  \",\n#   width: 200,\n#   height: 113\n# }\n```","ref":"ReqEmbed.html#module-usage"},{"type":"function","title":"ReqEmbed.attach/2","doc":"Attach the oEmbed plugin into Req.","ref":"ReqEmbed.html#attach/2"},{"type":"function","title":"Options - ReqEmbed.attach/2","doc":"* `:query` (`t:map/0`) - Defaults to `%{}`. The query parameters to be sent to the oEmbed endpoint,\n    like `:maxwidth`, `:maxheight`, and others supported by the provider.\n    The parameters `:url` and `:format` are managed by the plugin, you can't override them.\n    See section [2.2 Consumer Request](https://oembed.com/#section2) for more info.\n\n  * `:discover` (`t:boolean/0`) - Defaults to `true`. When enabled, it will first attempt to auto-discover\n    the oEmbed endpoint by looking for the link tag in the HTML response. If no link tag is found, it will\n    fallback to searching for a known provider endpoint. When disabled, it will skip the HTML parsing step\n    and only use the known provider endpoints.","ref":"ReqEmbed.html#attach/2-options"},{"type":"function","title":"Examples - ReqEmbed.attach/2","doc":"iex> req = Req.new() |> ReqEmbed.attach()\n    iex> Req.get!(req, url: \"https://www.youtube.com/watch?v=XfELJU1mRMg\").body\n    %ReqEmbed.Video{\n      title: \"Rick Astley - Never Gonna Give You Up (Official Music Video)\",\n      html: \"<iframe width=\"200\" height=\"113\" src=\"https://www.youtube.com...\n      ...\n    }","ref":"ReqEmbed.html#attach/2-examples"},{"type":"module","title":"ReqEmbed.Content","doc":"Base oEmbed response parameters as defined in https://oembed.com/#section2.3.4\n\nThese are the common fields that all oEmbed response types may include:\n* `type` (required) - The resource type. Valid values are: photo, video, link, rich\n* `version` (required) - The oEmbed version number. Must be \"1.0\"\n* `title` (optional) - A text title describing the resource\n* `author_name` (optional) - The name of the author/owner of the resource\n* `author_url` (optional) - A URL for the author/owner of the resource\n* `provider_name` (optional) - The name of the resource provider\n* `provider_url` (optional) - The url of the resource provider\n* `cache_age` (optional) - The suggested cache lifetime for this resource, in seconds\n* `thumbnail_url` (optional) - A URL to a thumbnail image representing the resource\n* `thumbnail_width` (optional) - The width of the optional thumbnail\n* `thumbnail_height` (optional) - The height of the optional thumbnail\n\nNote: If thumbnail_url is present, thumbnail_width and thumbnail_height must also be present.","ref":"ReqEmbed.Content.html"},{"type":"module","title":"ReqEmbed.Link","doc":"The link type as defined in https://oembed.com/#section2.3.4.3\n\nThe simplest type that allows a provider to return any generic embed data without providing\neither the url or html parameters. Only includes the base Content fields.\n\nThe consumer may then link to the resource using the URL specified in the original request.\nThis type is useful when the resource cannot be embedded or when the consumer should just\nprovide a direct link to the resource.","ref":"ReqEmbed.Link.html"},{"type":"module","title":"ReqEmbed.Photo","doc":"The photo type as defined in https://oembed.com/#section2.3.4.1\n\nRepresents a static photo. Includes all base Content fields plus:\n* `url` (required) - The source URL of the image. Consumers should be able to insert this URL into an   element. Only HTTP and HTTPS URLs are valid\n* `width` (required) - The width in pixels of the image specified in the url parameter\n* `height` (required) - The height in pixels of the image specified in the url parameter\n\nPhoto responses must obey the maxwidth and maxheight request parameters.","ref":"ReqEmbed.Photo.html"},{"type":"module","title":"ReqEmbed.Rich","doc":"The rich type as defined in https://oembed.com/#section2.3.4.4\n\nUsed for rich HTML content that does not fall under other categories. Includes all base Content fields plus:\n* `html` (required) - The HTML required to display the resource. The HTML should have no padding or margins.\n  The markup should be valid XHTML 1.0 Basic\n* `width` (required) - The width in pixels required to display the HTML\n* `height` (required) - The height in pixels required to display the HTML\n\nRich responses must obey the maxwidth and maxheight request parameters.\nConsumers may wish to load the HTML in an off-domain iframe to avoid XSS vulnerabilities.","ref":"ReqEmbed.Rich.html"},{"type":"module","title":"ReqEmbed.Video","doc":"The video type as defined in https://oembed.com/#section2.3.4.2\n\nRepresents a playable video. Includes all base Content fields plus:\n* `html` (required) - The HTML required to embed a video player. The HTML should have no padding or margins\n* `width` (required) - The width in pixels required to display the HTML\n* `height` (required) - The height in pixels required to display the HTML\n\nVideo responses must obey the maxwidth and maxheight request parameters.\nIf a provider wishes the consumer to just provide a thumbnail rather than an embeddable player,\nthey should instead return a photo response type.","ref":"ReqEmbed.Video.html"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"0.1.1 (2025-03-12) - Changelog","doc":"","ref":"changelog.html#0-1-1-2025-03-12"},{"type":"extras","title":"Added - Changelog","doc":"* Option `:discover` to turn discovery on/off","ref":"changelog.html#added"},{"type":"extras","title":"0.1.0 (2025-03-12) - Changelog","doc":"* Initial release","ref":"changelog.html#0-1-0-2025-03-12"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.3"}}